var Cus01200_CurvaABCServicoRealizadoController = function (ScreenService, restEngine, maskEngine, ZhUtil, General, GeneralServices, templateManager) {
/*global getLocalVar moment Util Configuration*/
	var dataSetTree;
	var parent;
	var codigo;
	var unidade;
	var filterReport;
	var self = this;

	this.setaNomeRelatorio = function (widget) {
		var relatorio = widget.getField('REPORT_NAME').dataSource.getFirstRow();
		
		if (!widget.currentRow.CDFILIAL) {
			widget.newRow();
		}

		widget.currentRow.REPORT_NAME = relatorio.value;
		GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL')).then(function (callback) {
			let defaultTipoCusto = callback.dataset.defaulttipocusto[0];
			if (defaultTipoCusto) {
				widget.getField('CDNMTIPOCUSTO').setValue(defaultTipoCusto.NMTIPOCUSTO);
				widget.currentRow.CDTIPOCUSTO = defaultTipoCusto.CDTIPOCUSTO;
				widget.currentRow.NMTIPOCUSTO = defaultTipoCusto.NMTIPOCUSTO;
			}
		});
	};

	this.atualizaListaDeServico = function (widget) {
		var grupoServicos = '';
		var currentRow = widget.currentRow;

		if (currentRow.ALLGRUPSERV == 'N') {
			if (currentRow.NMGRUPSERV.length) {
				grupoServicos = currentRow.NMGRUPSERV.join('_');
			} else {
				grupoServicos = '';
			}
		} else {
			grupoServicos = 'T';
		}
		General.onClickDependentField(widget.getField('NMSERVICO'), {
			CDFILIAL: currentRow.CDFILIAL,
			CDGRUPSERV: grupoServicos
		});
	};

	this.tipoProduto = function (fieldIdEstocaveis, fieldIdNestocaveis) {
		var mensagem = "O tipo de produto não foi informado";

		if (!fieldIdNestocaveis.checked && !fieldIdEstocaveis.checked) {
			ScreenService.showMessage(mensagem);
			return false;
		}
		return true;
	};

	this.retornaCurvaABC = function (currentRow) {
		return restEngine.post('cus_relatorio#/cus01200_curva_abc_servico_realizado', {
			"requestType": "Row",
			"row": currentRow
		}, null, null, null, null, 35000);
	};

	this.validaNivel = function (currentRow) {
		var mensagem = "O produto inicial não pode ser maior que o final.";
		var retorno = '';

		if (currentRow.CDARVPRODINI && currentRow.CDARVPRODFINAL) {
			retorno = General.comparaPratoProduto(currentRow.CDARVPRODINI, currentRow.CDARVPRODFINAL, getLocalVar('CDPICTPROD'));
			if (!retorno) {
				ScreenService.showMessage(mensagem);
				return false;
			}
			return true;
		}
		return false;
	};

	this.validaCampos = function (currentRow, widget, args) {
    	let reportFormats = [
		    {
		        name: "pdf",
		        value: "PDF"
		    },
		    {
		        name: "xlsx",
		        value: "XLSX"
		    }
		];
		let fieldIdEstocaveis = widget.getField('PRODESTOC');
		let fieldIdNestocaveis = widget.getField('PRODNAOESTOC');
		if (widget.isValid() && self.tipoProduto(fieldIdEstocaveis, fieldIdNestocaveis)) {
			if (self.validaNivel(currentRow)) {
				General.openReportPopup(widget, this.abreRelatorio, [widget, currentRow, args], reportFormats);
			}
		}
	};
	
	this.abreRelatorio = function (widget, currentRow, args) {
		if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLCDSERVFILI == 'N') {
			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');
		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLCDSERVFILI == 'N') {
			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = currentRow.NMSERVICO.join('_');
		} else if (currentRow.ALLGRUPSERV == 'N' && currentRow.ALLCDSERVFILI == 'S') {
			currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
			currentRow.LISTASERV = 'REQUEST';
		} else if (currentRow.ALLGRUPSERV == 'S' && currentRow.ALLCDSERVFILI == 'S') {
			currentRow.LISTAGRUPSERV = 'T';
			currentRow.LISTASERV = 'T';
		}
		currentRow.CDPICTPROD = '!' + getLocalVar('CDPICTPROD').replace(/[^(/\.|\ )]/g, "@");
		self.salvaFilial(widget);
		General.openReport('cus_relatorio#/cus01200_curva_abc_servico_realizado', currentRow.REPORT_NAME, args.row);
	};

	this.setaStripe = function (stripeWidget, parent) {
		stripeWidget.getField('unidade').setValue(codigo + ' | ' + unidade);

		if (parent.length) {
			parent[0].CUSTOTOTPROD = applyMask(parent[0].CUSTOTOTPROD, 2);
			var custoTotal =  parent[0].CUSTOTOTPROD.replace(".", ",");
			stripeWidget.getField('CUSTOTOTPROD').setValue(custoTotal);
		}
	};

	var applyMask = function (fieldValue, maxlength) {
		var mask = {
			"type": "zerofill",
			"params": {
				"right": true,
				"maxlength": maxlength
			}
		};
		return Util.applyMask(fieldValue, mask, maskEngine, ZhUtil);
	};

	this.setaDataSet = function (gridWidget, stripeWidget) {
		var history = ScreenService.getHistory();
		
		if (history.length > 1) {
			gridWidget.activate();
			parent = dataSetTree ? dataSetTree.splice(0, 1) : [];
			this.setaStripe(stripeWidget, parent);
			gridWidget.dataSource.data = dataSetTree;
			gridWidget.beforeGenerateReport = beforeGenerateReport;
		} else {
			ScreenService.openWindow('cus_relatorio#cus01200_curva_abc_por_servico_realizado');
		}
	};

	this.salvaFilial = function (widget) {
		codigo = widget.currentRow.CDFILIAL;
		unidade = widget.currentRow.NMFILIAL;
	};
	
	this.setDateValuesOnCurrentRow = function(field){
        var widget = field.widget;

        widget.currentRow.DTINICIAL = field.value() ? field.value().start : "";
        widget.currentRow.DTFINAL = field.value() ? field.value().end : "";
    };
    
    this.setDefaultValues = function(widget) {
    	if(!widget.backupRow){
	    	var currentRow = widget.currentRow;
	    	var primeiroDia = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
			var ultimoDia = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');
			var INTERVALODATA = widget.getField('INTERVALODATA');
			var defaultValue = {
				start: getLocalVar('DTPROCESSA'),
				end: getLocalVar('DTPROCESSA'),
				formattedStart: getLocalVar('DTPROCESSA'),
				formattedEnd: getLocalVar('DTPROCESSA')
			};
			INTERVALODATA.defaultValue = defaultValue;
			currentRow.DTINICIAL = getLocalVar('DTPROCESSA');
	        currentRow.DTFINAL = getLocalVar('DTPROCESSA');
			currentRow.DTMESINIC = primeiroDia;
			currentRow.DTMESFINA = ultimoDia;
			currentRow.CDFILIAL = getLocalVar('CDFILIAL');
			currentRow.NMFILIAL = getLocalVar('CDFILIAL') + ' | ' + getLocalVar('NMFILIAL');
    	}
		

    };

	this.onChangeGrupoServico = function (fieldNmServicoe) {
		fieldNmServicoe.setValue([]);
	};
	
	var beforeGenerateReport = function(callback){
		callback.metadata.filter = filterReport;
	};
	
};

Configuration(function (ContextRegister) {
	ContextRegister.register('Cus01200_CurvaABCServicoRealizadoController', Cus01200_CurvaABCServicoRealizadoController);
});