var Cus02600_CurvaABCCustoPlanejadoXRealizadoController = function(ScreenService, restEngine, maskEngine, ZhUtil, templateManager, General, GeneralServices) {
	/*global moment, getLocalVar, Configuration, Util*/
	var dataSetTree;
	var parent;
	var relatorio;
	var nomeRelatorio;
	var tela;
	var stripe;
	var idDiferenca;
	var codigo;
	var unidade;
	var self = this;

	this.setaNomeRelatorio = function(widget) {
		var relatorioDefault = widget.getField('REPORT_NAME').dataSource.getFirstRow();
		
		if (!widget.currentRow.CDFILIAL) {
			widget.newRow();
		}
	
		widget.currentRow.REPORT_NAME = relatorioDefault.name;
		widget.currentRow.CD_REPORT_NAME = relatorioDefault.value;
		widget.currentRow.DTINTERVAL = {
			start: moment().format('DD/MM/YYYY'),
			formattedStart: moment().format('DD/MM/YYYY'),
			end: moment().format('DD/MM/YYYY'),
			formattedEnd: moment().format('DD/MM/YYYY')
		};

		GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL')).then(function(callback) {
			if(callback.dataset.defaulttipocusto[0]) {	
				widget.getField('NMTIPOCUSTOPLAN').setValue(callback.dataset.defaulttipocusto[0].NMTIPOCUSTO);
				widget.currentRow.CDTIPOCUSTOPLAN = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
				widget.getField('NMTIPOCUSTOREAL').setValue(callback.dataset.defaulttipocusto[0].NMTIPOCUSTO);
				widget.currentRow.CDTIPOCUSTOREAL = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
			}
		});
	};

	this.atualizaListaDeServico = function(widget) {
		var grupoServicos = '';
		var currentRow = widget.currentRow;

		if(currentRow.TodosGruposServicos == 'N') {
			if (currentRow.NMGRUPSERV.length) {
				grupoServicos = currentRow.NMGRUPSERV.join('_');
			} else {
				grupoServicos = '';
			}
		} else {
			grupoServicos = 'T';
		}

		General.onClickDependentField(widget.getField('NMSERVICO'), {CDFILIAL: currentRow.CDFILIAL, CDGRUPSERV: grupoServicos});
	};

	this.tipoProduto = function(fieldIdEstocaveis, fieldIdNestocaveis) {
		var mensagem = "O tipo de produto não foi informado";

		if(!fieldIdNestocaveis.checked && !fieldIdEstocaveis.checked) {
			ScreenService.showMessage(mensagem);
			return false;
		}

		return true;
	};

	this.retornaCurvaABC = function(currentRow) {
		return restEngine.post('cus_relatorio#/cus02600_curva_abc_custo_planejado_realizado', {
            "requestType": "Row",
            "row": currentRow
		}, null, null, null, null, 60000);
	};

	this.validaNivel = function(currentRow) {
        var mensagem = "O produto final não pode ser maior que o inicial.";
        var retorno = '';
        
        if(currentRow.CDPRODINICIO && currentRow.CDPRODFINAL) {
			retorno = General.comparaPratoProduto(currentRow.CDARVPRODINICIO, currentRow.CDARVPRODFINAL, getLocalVar('CDPICTPROD'));
			
            if (!retorno) {
                ScreenService.showMessage(mensagem);
                return false;
            }
            return true;
		}
		
        return false;
    };

	this.selecionaRelatorio = function(currentRow) {
		relatorio = currentRow.CD_REPORT_NAME;
		nomeRelatorio = currentRow.REPORT_NAME;
		var mensagem = "Não há dados a serem listados";

		if(relatorio == "Cus02600") {
			this.retornaCurvaABC(currentRow).then(function(callback) {
				dataSetTree = callback.dataset.cus02600_abcplanrealdata;

				if(!dataSetTree[0]) {
					ScreenService.showMessage(mensagem);
				} else {
					ScreenService.openWindow('cus_relatorio#cus02600_grid_relatorio');
				}
			}, function() {
				ScreenService.showMessage('Operação não realizada. <br>Verifique sua conexão e tente novamente.');
			});
		} else {
			this.retornaCurvaABC(currentRow).then(function(callback) {
				dataSetTree = callback.dataset.cus02600_abcplanrealproduto;

				if(!dataSetTree[0]) {
					ScreenService.showMessage(mensagem);
				} else {
					ScreenService.openWindow('cus_relatorio#cus02600_grid_relatorio');
				}
			}, function() {
				ScreenService.showMessage('Operação não realizada. <br>Verifique sua conexão e tente novamente.');
			});
		}
	};

	this.validaCampos = function(currentRow, widget, args) {
		let fieldIdEstocaveis = widget.getField('PRODESTOC');
		let fieldIdNestocaveis = widget.getField('PRODNAOESTOC');
		currentRow.DTINICIAL = currentRow.DTINTERVAL.start;
		currentRow.DTFINAL = currentRow.DTINTERVAL.end;
		if(currentRow.NMFILIAL.includes('|'))
			currentRow.NMFILIAL = currentRow.NMFILIAL.split('|')[1];
		widget.currentRow.CDPICTPROD = getLocalVar("CDPICTPROD").replace(/[^(/\.|\ )]/g, "@");
		if(self.tipoProduto(fieldIdEstocaveis, fieldIdNestocaveis)) { 
			if(widget.isValid() && self.validaNivel(currentRow)) {
				self.salvaFilial(widget);

				if (currentRow.TodosGruposServicos == 'N' && currentRow.TodosServicos == 'N') {
					currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
					currentRow.LISTASERV = currentRow.NMSERVICO.join('_');
				} else if (currentRow.TodosGruposServicos == 'S' && currentRow.TodosServicos == 'N') {
					currentRow.LISTAGRUPSERV = 'T';
					currentRow.LISTASERV = currentRow.NMSERVICO.join('_');
				} else if (currentRow.TodosGruposServicos == 'N' && currentRow.TodosServicos == 'S') {
					currentRow.LISTAGRUPSERV = currentRow.NMGRUPSERV.join('_');
					currentRow.LISTASERV = 'REQUEST';
				} else if (currentRow.TodosGruposServicos == 'S' && currentRow.TodosServicos == 'S') {
					currentRow.LISTAGRUPSERV = 'T';
					currentRow.LISTASERV = 'T';
				}
				currentRow.DTMESINIC = moment(currentRow.DTINICIAL, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
				currentRow.DTMESFINA = moment(currentRow.DTFINAL, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');

				idDiferenca = widget.currentRow.IDDIFERENCA;
				//this.selecionaRelatorio(currentRow);
				General.openReport('cus_relatorio#/cus02600_curva_abc_planejado_realizado_report', currentRow.CD_REPORT_NAME, args.row);
			}
			
		}
	};

	this.abreRelatorio = function (currentRow, widget, args) {
		let reportFormats = [
		    {
		        name: "pdf",
		        value: "PDF"
		    },
		    {
		        name: "xlsx",
		        value: "XLSX"
		    }
		];
	        
		General.openReportPopup(widget, self.validaCampos, [currentRow, widget, args], reportFormats);
	};

	this.selecionaWidget = function(container) {
		if(relatorio == "Cus02600") {
			tela = container.getWidget('gridWidgetData');
			tela.isVisible = true;
			container.getWidget('gridWidgetConsumo').isVisible = false;
			container.getWidget('gridWidgetProduto').isVisible = false;
		} else if(relatorio == "Cus02601") {
			tela = container.getWidget('gridWidgetConsumo');
			tela.isVisible = true;
			container.getWidget('gridWidgetData').isVisible    = false;
			container.getWidget('gridWidgetProduto').isVisible = false;
		} else {
			tela = container.getWidget('gridWidgetProduto');
			tela.isVisible 	= true;
			container.getWidget('gridWidgetData').isVisible    = false;
			container.getWidget('gridWidgetConsumo').isVisible = false;
		}

		if (idDiferenca == 'P') {
			tela.getField('PERCENTUAL').label = "% de Variação Per Capita";
			tela.getField('DIFERENCA').label = "Diferença Per Capita";
		} else {
			tela.getField('PERCENTUAL').label = "% de Variação Total";
			tela.getField('DIFERENCA').label = "Diferença Total";
		}
	};

	var applyMask = function(fieldValue, maxlength) {
        var mask = {
            "type": "zerofill",
            "params": {
                "right": true,
                "maxlength": maxlength
            }
		};
		
        return Util.applyMask(fieldValue, mask, maskEngine, ZhUtil);
    };

	this.setaStripe = function(stripeWidget, parent) {
		stripeWidget.getField('unidade').setValue(codigo + ' - ' + unidade);		
		stripeWidget.getField('relatorio').setValue(nomeRelatorio);

		if (parent.length) {
			parent[0].PERCENTUAL  			= applyMask(parent[0].PERCENTUAL, 2);
	        parent[0].DIFERENCA   			= applyMask(parent[0].DIFERENCA, 2);
	        parent[0].CUSTO_PLAN     		= applyMask(parent[0].CUSTO_PLAN, 2);
	        parent[0].CUSTO_REAL    		= applyMask(parent[0].CUSTO_REAL, 2);
	        parent[0].CUSTO_PLAN_PERCAPITA  = applyMask(parent[0].CUSTO_PLAN_PERCAPITA, 2);
	        parent[0].CUSTO_REAL_PERCAPITA  = applyMask(parent[0].CUSTO_REAL_PERCAPITA, 2);

			stripeWidget.getField('custoPlanTot').setValue(parent[0].CUSTO_PLAN);
			stripeWidget.getField('comensais').setValue(parent[0].QTCOMENSAIS);
			stripeWidget.getField('custoPlanPercapita').setValue(parent[0].CUSTO_PLAN_PERCAPITA);
			stripeWidget.getField('custoRealTot').setValue(parent[0].CUSTO_REAL);
			stripeWidget.getField('efetivos').setValue(parent[0].QTEFETIVOS);
			stripeWidget.getField('custoRealPercapita').setValue(parent[0].CUSTO_REAL_PERCAPITA);
			stripeWidget.getField('diferenca').setValue(parent[0].DIFERENCA);
			stripeWidget.getField('variacao').setValue(parent[0].PERCENTUAL);
		}		
	};

	this.setaDataSet = function(stripeWidget) {
		tela.activate();
		parent = dataSetTree.splice(0, 1);
		this.setaStripe(stripeWidget, parent);
		tela.dataSource.data = dataSetTree;
	};

	// this.excluiConsplan = function() {
	// 	return restEngine.post('cus_relatorio#/cus02600_exclui_consplan', {
    //         "requestType": "Row",
    //         "row": {}
	// 	});
	// };

	this.setaCurrentRow = function(widget) {
		if(widget.currentRow) {
			if (!widget.currentRow.REPORT_NAME) {
				this.setaNomeRelatorio(widget);	
			}
			widget.setCurrentRow(widget.currentRow);
		} else {
			this.setaNomeRelatorio(widget);
		}
		templateManager.updateTemplate();
	};
	
	this.salvaFilial = function(widget) {
		codigo  = widget.currentRow.CDFILIAL;
		unidade = widget.currentRow.NMFILIAL;
	};

	this.bindOutDataCurrentRow = function(field){
        let widget  = field.widget;
		let outData = field._outData;
		
        if(outData){
            Object.keys(outData).forEach(function(property){
                widget.currentRow[outData[property]] = outData[property] === field.name ? 
                    widget.currentRow[outData[property]] : widget.currentRow[property];
            });
        }
        if(field.name === 'NMPRODINICIO') {
	        widget.currentRow.NMPRODFINAL = angular.copy(widget.currentRow.NMPRODINICIO);
	        widget.currentRow.CDARVPRODFINAL = angular.copy(widget.currentRow.CDARVPRODINICIO);
	        widget.currentRow.CDPRODFINAL = angular.copy(widget.currentRow.CDPRODINICIO);
        }
	};
	
	this.trocaVisibilidadeTipoProduto = function(args){
		let widget = args.owner.field.widget;
		if(widget.currentRow.CD_REPORT_NAME == 'CUS02600'){
			widget.fieldGroups.filter(field => field.name == 'TIPOPROD')[0].isVisible = true;
		}else{
			widget.fieldGroups.filter(field => field.name == 'TIPOPROD')[0].isVisible = false;
		}
			templateManager.updateTemplate();
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus02600_CurvaABCCustoPlanejadoXRealizadoController', Cus02600_CurvaABCCustoPlanejadoXRealizadoController);
});